function GivePlayerWeapon(className, itemID)
{
    local weapon = Entities.CreateByClassname(className);
    SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
    SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
    SetPropBool(weapon, "m_bForcePurgeFixedupStrings", true);
    weapon.SetTeam(self.GetTeam());
    weapon.SetOwner(self);
	SetPropEntity(weapon, "m_hOwnerEntity", self);
    Entities.DispatchSpawn(weapon);

    self.Weapon_Equip(weapon);
    self.Weapon_Switch(weapon);

    return weapon;
}

function CreateViewModel(modelName)
{
    local viewModel = SpawnEntityFromTable("tf_wearable_vm", { })
	viewModel.SetModelSimple(modelName);
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
    self.EquipWearableViewModel(viewModel);
    viewModel.ValidateScriptScope();
    viewModel.GetScriptScope().characterName <- characterName;
	return viewModel;
}

function CreateWorldModel(modelName)
{
    local worldModel = SpawnEntityFromTable("tf_wearable", { });
	worldModel.SetModelSimple(modelName);
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	SetPropEntity(worldModel, "m_hOwnerEntity", self);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, self, self);
    worldModel.ValidateScriptScope();
    worldModel.GetScriptScope().characterName <- characterName;
	return worldModel;
}