characterName <- "vip";
characterClass <- TF_CLASS_DEMOMAN;
characterModel <- API_GetString("vip_model");

IncludeScript("vip/vip/vip_buff_lockon.nut");
IncludeScript("vip/vip/vip_buffs.nut");
IncludeScript("vip/vip/vip_headshot.nut");
IncludeScript("vip/vip/vip_nag.nut");
IncludeScript("vip/vip/vip_mediccall.nut");
IncludeScript("vip/vip/vip_fixes.nut");

EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_dispenser.nut",
    thinkfunction = "DispenserThink",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);

EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
{
    origin = self.GetCenter(),
    vscripts = "vip/entities/vip_team_outline.nut",
    TeamNum = GetFakeTeam(self)
}), "SetParent", "!activator", 0, self, self);

AddTimer(1, function()
{
    local hp = self.GetHealth();
    local newHP = clampCeiling(self.GetMaxHealth(), hp + 3);
    if (hp > 0 && newHP > hp)
        self.SetHealth(newHP);
});

OnSelfGameEvent("post_inventory_application", 0, function()
{
    self.AddHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    vipBoostTokens <- vipBoostTokensStart;
    self.KeyValueFromString("targetname", "vip");

    for (local droppedWeapon = null; droppedWeapon = Entities.FindByClassname(droppedWeapon, "tf_dropped_weapon");)
        if (droppedWeapon.GetModelName() == "models/workshop/weapons/c_models/c_paintrain/c_paintrain.mdl")
        {
            droppedWeapon.Kill();
            break;
        }

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("dmg taken from fire reduced", 0.8, -1);
    self.AddCustomAttribute("dmg taken from crit reduced", 0.8, -1);
    self.AddCustomAttribute("damage bonus HIDDEN", 0.54, -1);
    self.AddCustomAttribute("fire rate bonus HIDDEN", 0.625, -1);

    self.SetHealth(175);
    self.SetMaxHealth(175);

    vipBoostTokens = vipBoostTokensMax;

    local weapon = GivePlayerWeapon("tf_weapon_shovel", 6);
    weapon.SetModelSimple(API_GetString("vip_arms_model"));
    weapon.SetCustomViewModelModelIndex(GetModelIndex(API_GetString("vip_arms_model")));
    SetPropInt(weapon, "m_iViewModelIndex", GetModelIndex(API_GetString("vip_arms_model")));
    weapon.DisableDraw();

    local stockViewmodelEnt = GetPropEntity(self, "m_hViewModel");
    stockViewmodelEnt.DisableDraw();
    stockViewmodelEnt.SetModelSimple(API_GetString("vip_arms_model"));

    CreateViewModel(API_GetString("vip_arms_model"));
    CreateViewModel(API_GetString("cane_model"));
    CreateWorldModel(API_GetString("cane_model"));
    CreateWorldModel(API_GetString("vip_hat_model"));
});

OnSelfGameEvent("player_death", 0, function(player, params)
{
    KillLockVFX();
    DoEntFire(GetFakeTeamName(player) + "_vip_death*", "Trigger", "", -1, player, player);
    FireCustomEvent("vip_death", params);
});